<?php

/*

    FASDIM: Fast And Simple DeIdentification Method
    Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/


print("
STEP 03
This program lists the TXT files candidate for de-identification (txt_nonano).
") ;

$liste_param=array('txt_nonano', 'txt_preano',
	'database_dsn', 'database_user', 'database_password',
	'table_txtnonano2txtpreano'
) ;



require_once('./scripts/fasdim_include.inc') ;


/* ======================= Parameters ============================= */


$rep_courriers_entree =  $fasdim_config['txt_nonano'] ;
$rep_courriers_sortie =  $fasdim_config['txt_preano'] ;
$bdd_dsn = $fasdim_config['database_dsn']  ;
$bdd_user = $fasdim_config['database_user']  ; ;
$bdd_pwd = $fasdim_config['database_password'] ;
$nom_table = $fasdim_config['table_txtnonano2txtpreano'] ;

/* ======================= Main ============================= */

if( !is_dir($rep_courriers_entree)) {
	trigger_error( "Directory not available: $rep_courriers_entree", E_USER_ERROR) ;
}
if( !is_dir($rep_courriers_sortie)) {
	trigger_error( "Directory not available: $rep_courriers_sortie", E_USER_ERROR) ;
}

try {
	$bdd = new PDO(  $bdd_dsn, $bdd_user, $bdd_pwd ) ;
} catch (PDOException $e) {
	trigger_error('Connection failed: ' . $e->getMessage(), E_USER_ERROR) ;
}

$bdd->exec("CREATE TABLE $nom_table ( nom varchar(255) not null, statut char(1) not null, primary key (nom) )  ;");

$stt = $bdd->prepare("INSERT INTO $nom_table (nom, statut) VALUES (:nom, :statut) ;") ;


$fichiers_in = glob( $rep_courriers_entree .'/*.txt' ) ;
$nb_fichiers = count($fichiers_in) ;

print "\nThere are $nb_fichiers text files in the directory $rep_courriers_entree\n" ;

$barre = new barre_progression_batch(0,  $nb_fichiers ) ;
$barre->dessine() ;

for( $i=0; $i<$nb_fichiers; $i++) {
	$stt->execute(array(":nom"=> basename($fichiers_in[$i]), ":statut"=>0)) ;
	$barre->avance($i) ;
}



?>

STEP 03 DONE !!
