<?php


/*

    FASDIM: Fast And Simple DeIdentification Method
    Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

print("
STEP 05
This program extracts patterns from the prepared TXT files:
- tokens
- patterns around numbers
Then, you will have to filter those patterns and define the allowed words and the number protection patterns.
Only one instance of the program must be run in the same time.
") ;

$liste_param=array('txt_preano',
	'database_dsn', 'database_user', 'database_password',
	'table_txtnonano2txtpreano',
	'tokens_to_filter', 'number_contexts_to_filter'
) ;


require_once('./scripts/fasdim_include.inc') ;


/* ======================= Parameters ============================= */

$out_dico_mots = $fasdim_config['tokens_to_filter'] ;
$out_dico_nombres = $fasdim_config['number_contexts_to_filter'] ;  // !!!! not yet implemented
$rep_courriers_txt_nonano =  $fasdim_config['txt_preano'] ;

$bdd_dsn = $fasdim_config['database_dsn']  ;
$bdd_user = $fasdim_config['database_user']  ; ;
$bdd_pwd = $fasdim_config['database_password'] ;
$nom_table = $fasdim_config['table_txtnonano2txtpreano'] ;


/* ======================= Functions ============================= */






// This function registers iteratively the list of words. This is useful as the program may stop during the execution.
function enregistre_dictionnaires() {
	GLOBAL $dictionnaire, $out_dico_mots, $dictionnaire_nombres, $out_dico_nombres ;

	print "\tRegister list of words.." ;
	// l'enregistrement du dictionnaire des mots
	arsort( $dictionnaire ) ;
	$fp = fopen( $out_dico_mots, 'w' ) ;
	foreach( $dictionnaire as $mot=>$eff) {
		fwrite( $fp, "$mot\t$eff\r\n" ) ;
	}
	fclose( $fp ) ;
	print ".OK\t" ;

	print "\tRegister list of number contexts.." ;
	arsort( $dictionnaire_nombres ) ;
	$fp = fopen( $out_dico_nombres, 'w' ) ;
	foreach( $dictionnaire_nombres as $mot=>$eff) {
		fwrite( $fp, "$mot\t$eff\r\n" ) ;
	}
	fclose( $fp ) ;
	print ".OK\t" ;
}

/*  =========== MAIN =========== */

try {
	$bdd = new PDO(  $bdd_dsn, $bdd_user, $bdd_pwd ) ;
} catch (PDOException $e) {
	trigger_error('Connection failed: ' . $e->getMessage(), E_USER_ERROR) ;
}


print( bdd_etat_verrous($bdd, $nom_table) );
$i=0 ;
print "\n\n\n$i records" ;


$dictionnaire = array() ;
$dictionnaire_nombres = array() ;

$liste_fichiers = get_file_list($bdd, $nom_table, 2) ;

$nb = count( $liste_fichiers ) ;
print "\nThere are $nb files to analyze." ;
$barre = new barre_progression_batch(0, $nb ) ;
$barre->dessine() ;
for( $i=0; $i<count($liste_fichiers) ; $i++) {
	$filename= $rep_courriers_txt_nonano.'/'.$liste_fichiers[$i] ;
	$string = file_get_contents( $filename ) ;
	// on extrait les mots diffrents
	$keywords = preg_split('/[\p{P}\p{S}\p{Z}\p{M}\\n\\r\s]+/', $string , -1, PREG_SPLIT_NO_EMPTY );  // respectivement ponctuation, symbole, sparateur, marque
	$tabcont = array_count_values( $keywords) ;
	foreach( $tabcont as $mot=>$eff) {
		if( !preg_match( '|^\d+$|i', $mot)) {
			if( isset( $dictionnaire[$mot] )) {
				$dictionnaire[$mot] += $eff ;
			} else {
				$dictionnaire[$mot] = $eff ;
			}
		}
	}
	// on extrait les motifs de nombres
	preg_match_all("|\b(\S+)\s*\d|iU", $string, $matches_left, PREG_PATTERN_ORDER);
	preg_match_all("|\d\s*(\S+)\b|iU", $string, $matches_right, PREG_PATTERN_ORDER);
	// $matches_left[1] ;
	// $matches_right[1] ;
	foreach($matches_left[1] as $un_mot) {
		if( !preg_match( '|^\d+$|i', $un_mot)) {
			$mot = $un_mot." ***" ;
			if( isset( $dictionnaire_nombres[$mot] )) {
				$dictionnaire_nombres[$mot] ++ ;
			} else {
				$dictionnaire_nombres[$mot] =1 ;
			}
		}
	}
	foreach($matches_right[1] as $un_mot) {
		if( !preg_match( '|^\d+$|i', $un_mot)) {
			$mot = "*** ". $un_mot ;
			if( isset( $dictionnaire_nombres[$mot] )) {
				$dictionnaire_nombres[$mot] ++ ;
			} else {
				$dictionnaire_nombres[$mot] =1 ;
			}
		}
	}
	$barre->avance($i) ;
	if( $i % 500==0 and $i>0 ) {
		enregistre_dictionnaires() ;
	}
}
enregistre_dictionnaires() ;


print "\n\n\n" ;
enregistre_dictionnaires() ;
print "\n\n\n" ;

?>




STEP 05 DONE
Please check the error log file if necessary.
Now, you should exam the output files and filter the token and numbers, in order to prepare next step.

