<?php


/*

    FASDIM: Fast And Simple DeIdentification Method
    Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

print("
STEP 07
This program proceeds the final de-identification of the prepared TXT files.
Several instances of the program can be run in the same time.
") ;

$liste_param=array('txt_preano', 'txt_ano',
	'database_dsn', 'database_user', 'database_password',
	'table_txtpreano2txtano',
	'tokens_to_protect' /*, 'number_contexts_to_protect'  */
) ;


require_once('./scripts/fasdim_include.inc') ;


/* ======================= Parameters ============================= */

$file_dictionnaire = $fasdim_config['tokens_to_protect'] ;
$out_dico_nombres = $fasdim_config['number_contexts_to_filter'] ;  // !!!! not yet implemented
$rep_entree =  $fasdim_config['txt_preano'] ;
$rep_sortie =  $fasdim_config['txt_ano'] ;

$bdd_dsn = $fasdim_config['database_dsn']  ;
$bdd_user = $fasdim_config['database_user']  ; ;
$bdd_pwd = $fasdim_config['database_password'] ;
$nom_table = $fasdim_config['table_txtpreano2txtano'] ;


/* ======================= Functions ============================= */







/* ======================= Main ============================= */


// ================ chargement du dictionnaire des mots autoriss
$dictionnaire = array() ;
$file = $file_dictionnaire ;
$fp = fopen( $file, 'r' ) ;
if( !$fp ) {
	trigger_error( "fichier introuvable $file", E_USER_ERROR ) ;
}
while( !feof( $fp ) ) {
	$line = fgets( $fp ) ;
	$cells = explode("\t", $line) ;
         $mot = trim($cells[0]) ;
	if( strlen($mot)>0) {
		$dictionnaire[] = $mot ;
	}
}
fclose( $fp ) ;

print "\nLe dictionnaire comporte ". count($dictionnaire) ." mots.\n" ;




// ================ traitement des fichiers
try {
    $bdd = new PDO(  $bdd_dsn, $bdd_user, $bdd_pwd ) ;
} catch (PDOException $e) {
    trigger_error('Connection failed: ' . $e->getMessage(), E_USER_ERROR) ;
}


print( bdd_etat_verrous($bdd, $nom_table) );
$i=0 ;
print "\n\n\n$i courriers" ;


while( $file = bdd_fichier_verrouille($bdd, $nom_table) ) {

	$un_file_in = $rep_entree.'/'. $file ;
	$un_file_out = $rep_sortie.'/'. $file ;
	$content = file_get_contents( $un_file_in ) ;

	// First, we protect some numbers before deleting all the others.
	$memoire_protection = array() ;

	/* We have tried to preserve fractions and drop dates, but it is too dangerous. As soon as there is a slash, we drop it.
	$content = preg_replace("|\b(\d+/\d+/\d+)\b|i", '@/@/@' ,$content ) ;
	if( preg_match_all ( "|\b(\d+/\d+)\b|i" ,$content, $matches, PREG_PATTERN_ORDER  ) ) {
		$memoire_protection = array_merge( $memoire_protection, $matches[0] ) ;
	} */
	
	// The following protection patterns should be externalized from the script in next versions of the program
	
	// number protection patterns with a word before the number
	$excuse_mots_avant = array( 'a', 	'acebutolol', 	'actiskenan', 	'actonel', 	'actos', 	'adancor', 	'aerius', 	'alat', 	'aldactone', 	'allopurinol', 	'alprazolam', 	'alumine', 	'amarel', 	'amiklin', 	'amiodarone', 	'amipril', 	'amlodipine', 	'amlor', 	'amoxicilline', 	'anafranil', 	'andris', 	'androcur', 	'anteversion', 	'aprovel', 	'arava', 	'arestal', 	'aricept', 	'arimidex', 	'arixtra', 	'aromasine', 	'artane', 	'asat', 	'aspegic', 	'aspirine', 	'atacand', 	'atarax', 	'atb', 	'atenolol', 	'athymil', 	'augmentin', 	'avandamet', 	'avlocardyl', 	'azantac', 	'bav', 	'betadine', 	'betahistine', 	'bionolyte', 	'biperidys', 	'bipreterax', 	'biprofenid', 	'bisoprolol', 	'bitildiem', 	'bricanyl', 	'bristopen', 	'bromazepam', 	'bronchodual', 	'buflomedil', 	'burinex', 	'calciparine', 	'captopril', 	'cardensiel', 	'carpezat', 	'casodex', 	'ceftriaxone', 	'celectol', 	'celiprolol', 	'cerafit', 	'cetornan', 	'chondrosulf', 	'chronadalate', 	'chrono', 	'cibacene', 	'ciflox', 	'ciprofloxacine', 	'citalopram', 	'clamoxyl', 	'clarithromycine', 	'clarityne', 	'coaprovel', 	'codeine', 	'colchicine', 	'colchimax', 	'contramal', 	'cordarone', 	'cortancyl', 	'corvasal', 	'cotareg', 	'coumadine', 	'coveram', 	'coversyl', 	'cozaar', 	'creatinine', 	'crestor', 	'cytokeratine', 	'dafalgan', 	'daflon', 	'daonil', 	'debridat', 	'denimal', 	'depakine',
		'depakote', 	'depamide', 	'deroxat', 	'detensiel', 	'diafusor', 	'diametre', 	'diamicron', 	'digoxine', 	'dilatrane', 	'discotrine', 	'diskus', 	'doliprane', 	'domperidone', 	'doxycycline', 	'duphalac', 	'durogesic', 	'ebixa', 	'efferalgan', 	'effervescent', 	'effexor', 	'elisor', 	'enalapril', 	'endotelon', 	'eprex', 	'equanil', 	'ernestine', 	'esidrex', 	'ethicrin', 	'eupressyl', 	'eurobiol', 	'exelon', 	'extranase', 	'ezetrol', 	'fenofibrate', 	'filapeau', 	'flagyl', 	'flecaine', 	'fluconazole', 	'fludex', 	'fluoxetine', 	'fonzylane', 	'forlax', 	'fortum', 	'fortzaar', 	'fucidine', 	'furosemide', 	'gabapentine', 	'gardenal', 	'gaviscon', 	'gentamicine', 	'glibenclamide', 	'gliclazide', 	'glimepiride', 	'glivec', 	'glucophage', 	'glucor', 	'granocyte', 	'havlane', 	'hbpm', 	'hemidaonil', 	'hemigoxine', 	'hemoglobine', 	'heparine', 	'hydrea', 	'hydrocortisone', 	'hyperium', 	'hyperten', 	'hypnovel', 	'hytacand', 	'icaz', 	'ikorel', 	'imovane', 	'imurel', 	'inegy', 	'inexium', 	'inipomp', 	'innohep', 	'iperten', 	'isoptine', 	'ixel', 	'ixprim', 	'j', 	'kaleorid', 	'kardegic', 	'keforal', 	'kenzen', 	'keppra', 	'kerlone', 	'kytril', 	'lamictal', 	'lamotrigine', 	'lantus', 	'lanzor', 	'laroxyl', 	'lasilix', 	'lectil', 	'leponex', 	'lepticur', 	'lescol', 	'levothyrox',
		'lexomil', 	'lioresal', 	'lipanthyl', 	'lisinopril', 	'lodoz', 	'lopril', 	'lorazepam', 	'lovenox', 	'loxapac', 	'loxen', 	'lp', 	'lyrica', 	'lysanxia', 	'mantadix', 	'mediatensyl', 	'medrol', 	'mercazole', 	'meteospasmyl', 	'meteoxane', 	'metformine', 	'methadone', 	'metronidazole', 	'mianserine', 	'micardis', 	'miflonil', 	'modopar', 	'molsidomine', 	'monotildiem', 	'mopral', 	'morphine', 	'motilium', 	'movicol', 	'myolastan', 	'naftidrofuryl', 	'naropeine', 	'nebilox', 	'neomercazole', 	'neupogen', 	'neurontin', 	'nicobion', 	'nifluril', 	'nisis', 	'nitriderm', 	'noctamide', 	'noctran', 	'norfloxacine', 	'noroxine', 	'norset', 	'novomix', 	'novonorm', 	'nozinan', 	'odrik', 	'oflocet', 	'ofloxacine', 	'ogast', 	'oliclinomel', 	'olmetec', 	'omeprazole', 	'orbenine', 	'oroken', 	'oxeol', 	'oxygene', 	'oxynorm', 	'pantoprazole', 	'par', 	'paracetamol', 	'parietex', 	'paroxetine', 	'pentasa', 	'perfalgan', 	'perindopril', 	'permixon', 	'persantine', 	'piracetam', 	'plavix', 	'polaramine', 	'polyethylene', 	'polysorb', 	'potassium', 	'pouls', 	'pradaxa', 	'pravastatine', 	'praxilene', 	'prednisolone', 	'prednisone', 	'pression', 	'preterax', 	'previscan', 	'primperan', 	'pritor', 	'procoralan', 	'profenid', 	'prolene', 	'propanolol', 	'prozac', 	'pulmicort', 	'pyostacine', 	'qsp', 	'ramipril', 	'ranitidine',
		'redon', 	'renitec', 	'rifadine', 	'rifater', 	'rilmenidine', 	'risperdal', 	'risperidone', 	'rivotril', 	'rocephine', 	'saturation', 	'sectral', 	'seresta', 	'seretide', 	'seroplex', 	'seropram', 	'sertraline', 	'sifrol', 	'simvastatine', 	'singulair', 	'sintrom', 	'skenan', 	'smecta', 	'solumedrol', 	'solupred', 	'soprol', 	'sotalex', 	'sotalol', 	'spagulax', 	'spasfon', 	'speciafoldine', 	'spiriva', 	'spironolactone', 	'stablon', 	'stagid', 	'stilnox', 	'subutex', 	'sulfarlem', 	'symbicort', 	'tadenan', 	'tahor', 	'tamaris', 	'tanakan', 	'tanganil', 	'tardyferon', 	'tareg', 	'targocid', 	'tavanic', 	'tazocilline', 	'tca', 	'tegretol', 	'temerit', 	'temesta', 	'temperature', 	'tenormine', 	'tenstaten', 	'tercian', 	'tgo', 	'tgp', 	'theralene', 	'tiapridal', 	'tienam', 	'tildiem', 	'tlc', 	'topalgic', 	'torental', 	'tramadol', 	'trandate', 	'transipeg', 	'tranxene', 	'triatec', 	'triflucan', 	'trileptal', 	'trimebutine', 	'trimetazidine', 	'trinipatch', 	'trinitrine', 	'trisomie', 	'trivastal', 	'turbuhaler', 	'umuline', 	'urbanyl', 	'utrogestan', 	'valium', 	'vancomycine', 	'vastarel', 	'vasten', 	'vectarion', 	'ventilastin', 	'ventoline', 	'verapamil', 	'veratran', 	'vgm', 	'vicryl', 	'vmax', 	'voltarene', 	'x', 	'xanax', 	'xatral', 	'xelevia', 	'xylocaine',
		'xyzall', 	'zanidip', 	'zeclar', 	'zelitrex', 	'zestril', 	'zocor', 	'zoloft', 	'zolpidem', 	'zophren', 	'zopiclone', 	'zyloric', 	'zyprexa', 	'zyvoxid' , 'aiguille', 'jour sur') ;
	foreach( $excuse_mots_avant as $mot ) {
		if( preg_match_all ( "|\b($mot\s*)(\d+ ?\d*[\.,]?\d*)|i" ,$content, $matches, PREG_PATTERN_ORDER  ) ) {
			$memoire_protection = array_merge( $memoire_protection, $matches[0] ) ;
		}
	}
	
	// number protection patterns with a word after the number: a white caracter is possible but not mandatory. In addition, the following word can eventually "begin like".
	$excuse_prefixes_apres = array( '/j', 	'%', 	'', '', 	'aerosol', 	'agrafe', 	'amp', 	'anteversion', 	'application', 	'battement', 	'biere', 	'bouteille', 	'bpm', 	'centi', 	'cigarette', 	'clip', 	'cm', 	'comprime', 	'cp', 	'culot', 	'cure', 	'cycle', 	'degre', 	'element', 	'episode', 	'flacon', 	'fois', 	'gamma', 	'ganglion', 	'gb', 	'gel', 	'germe', 	'globule', 	'goutte', 	'gtte', 	'heures', 	'hypopnee', 	'inhalation', 	'inj', 	'joule', 	'jour', 	'jr', 	'kpa', 	'leuco', 	'litre', 	'lympho', 	'meq', 	'mg', 	'million', 	'minute', 	'ml', 	'mm', 	'mu', 	'nano', 	'neutro', 	'ng', 	'pansement', 	'paquet', 	'perfusion', 	'plaquette', 	'pnn', 	'point', 	'poly', 	'prise', 	'pulsation', 	'repas', 	'sac', 	'sachet', 	'seconde', 	'selle', 	'semaine', 	'stent', 	'suppo', 	'torr', 	'u\.i', 	'unite', 	'verre', 'patch', 'le soir', 'le midi', 'le matin' , 'concentre' ) ;
	foreach( $excuse_prefixes_apres as $mot ) {
		if( preg_match_all ( "|(\d+ ?\d*[\.,]?\d*\s*$mot)|i" ,$content, $matches, PREG_PATTERN_ORDER  ) ) {
			$memoire_protection = array_merge( $memoire_protection, $matches[0] ) ;
		}
	}
	// number protection patterns with a word after the number: a white caracter is possible. The following word must be entire.
	$excuse_mots_apres = array( 'g', 	'gr', 	'l', 	'u', 	'ui', 	'x', 	'h' , 'par' , 'eme', 'ieme', 'nd','emes', 'iemes', 'er', 'ers' ) ;
	foreach( $excuse_mots_apres as $mot ) {
		if( preg_match_all ( "|(\d+ ?\d*[\.,]?\d*)(\s*$mot)\b|i" ,$content, $matches, PREG_PATTERN_ORDER  ) ) {
			$memoire_protection = array_merge( $memoire_protection, $matches[0] ) ;
		}
	}


	// the protection
	$memoire_protection2 = array() ;
	foreach( $memoire_protection as $index => $mot ) {
		$index2 = 'nombre'.$index.'findenombre' ; // this protection pattern doesn't contain any special character. Elsewise, it would be used to split the token again.
		$memoire_protection2[$index2] = $mot ;
		$content = str_replace($mot, $index2 , $content) ;
	}

	// $content = preg_replace('|\d+|', '@', $content) ;

	// We drop the words that don't belong to the list of authorized words
	$keywords = preg_split('/[\p{P}\p{S}\p{Z}\p{M}\\n\\r\s]+/', $content , -1, PREG_SPLIT_NO_EMPTY );
	$mots_hors_dico = array() ;
	foreach( $keywords as $un_mot ) {
		// except if the word is a number
		if( ! strstr($un_mot, 'nombre') AND ! strstr($un_mot, 'findenombre') ) {
			if( $un_mot!='@' AND ! in_array($un_mot, $dictionnaire) ) {
				$content = preg_replace("|\b$un_mot\b|iU", '@', $content )  ;
			}
		}
	}

	// then we replace the protected numbers
	foreach( $memoire_protection2 as $index2 => $mot ) {
		// $content = str_replace($index2, '<<<<'. $mot .'>>>>' , $content) ;  // permet de voir les nombres protgs
		$content = str_replace($index2,  $mot , $content) ;
	}

	// finally we records the new file
	file_put_contents( $un_file_out, $content ) ;

         bdd_fichier_deverrouille($bdd, $nom_table, $file) ;
	$i++ ;
         print "\r$i courriers" ;


}


print( "\n\n". bdd_etat_verrous($bdd, $nom_table) . "\n\n" );



?>



STEP 07 DONE
Please check the error log file if necessary.
