FASDIM is an open-source program that helps you to de-identify French free-text medical records.
It is distributed without any warranty. Please read the terms of the GNU GPL license.
It also uses the GnuWin32 Library and WV 1.0.2, under GNU GPL license. Please read the corresponding licenses.
(C) Emmanuel Chazard, 2013-07-14

Errors are redirected to a log file.

<?php


/*

    FASDIM: Fast And Simple DeIdentification Method
    Copyright (C) 2013 Emmanuel Chazard http://emmanuel.chazard.org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/



ini_set("display_errors",'Off');
ini_set("error_reporting",E_ALL);
ini_set("log_errors",'On');
ini_set("error_log","./errors.log");



/*
	use this file to set basic configuration
   	Set relative path to the files in relation to the path where the *.bat files are present
   	Do not use slashes to end directory names. Use slashes '/' and not '\' to separate elements of the path
   	The values provided are only examples of course

      Please excuse the quality of this preliminary version : my text editor is not gorgeous, and I should transform the code to OOP code...
*/

$fasdim_config = array(
	'doc_nonano'=>'./data1_doc_nonano',  // initial path with DOC files (must already exist)
	'txt_nonano'=>'./data2_txt_nonano',  // (temporary or initial) path with TXT files (must already exist)
	'txt_preano'=>'./data3_txt_preano',  // temporary path with modified TXT files (must already exist, empty)
	'txt_ano'=>'./data4_txt_ano',  	 // final path with de-identified TXT files (must already exist, empty)
	'database_dsn' => "mysql:host=localhost;dbname=fasdim", // info required by PDO to connect to the database. The database must already exist.
	'database_user' => 'root',
	'database_password' => '',
	'table_docnonano2txtnonano' => 'work1_docnonano2txtnonano',	// SQL table used for tracing (created by the program)
	'table_txtnonano2txtpreano' => 'work1_txtnonano2txtpreano',	// SQL table used for tracing (created by the program)
	'table_txtpreano2txtano' => 'work1_txtpreano2txtano',		// SQL table used for tracing (created by the program)
	'wvware' => 'scripts\\GnuWin32\\bin\\wvware.exe  --config ./scripts/fasdim_wvtext.xml ',		// command line to convert DOC to TXT, to complete with DOC filename and TXT filename
	'file_reports'=>'./in/report.txt',		// a tabulated text file with, for each report, the patient ID (if available, or FALSE): id_hosp	id_stay	id_patient	kind	filename
	'file_patients_names'=>'./in/name.txt',	// a tabulated text file with, for each patient ID, the names of the patient (if available, or FALSE): id_hosp	id_patient	lastname1	lastname2	firstname	birthdate
	'tokens_to_filter'=>'./out/tokens_to_filter.txt', // the tokens that have been detected by the program, to filter by the user
	'number_contexts_to_filter'=>'./out/number_contexts_to_filter.txt', // the number contexts that have been detected by the program, to filter by the user
	'tokens_to_protect'=>'./in/tokens_to_protect.txt', // the tokens that can be kept in the records (filtered by the user)
	'number_contexts_to_protect'=>'./in/number_contexts_to_protect.txt', // the number contexts that can be kept in the records (filtered by the user)  !!! not implemented yet, writen directly in the script...
	
) ;


?>

The program will be run with the following configuration.
It can be modified in the fasdim_include.inc file.
Only items marked with "***" will be used in this step.

<?php

foreach( $fasdim_config as $key => $value) {
	if( isset($liste_param) and in_array($key, $liste_param)) {
		print "***\t" ;
	} else {
		print "\t" ;
	}
	print str_pad($key,30)."$value\n" ;
}

print "\nContinue with those parameters (y/n)?\n" ;
$answer = strtolower(trim(fgets(STDIN))) ;

if( $answer!='y') {
	exit ;
}















// Here, some functions or classes that may be shared



/**
* classe de barre de progression prsentant un vrai pourcentage d'avancement.
*/

class barre_progression_batch {
    private static $compteur ;
    private $min ;
    private $max ;
    private $avancement =0;
    private $image_gauche ;
    private $image_droite ;

    /**
    * Constructeur
    *
    * Le constructeur dsactive la bufferisation de sortie.
    *
    * @param int $min Plancher de l'chelle
    * @param int $max Plafond de l'chelle
    * @param string $image_gauche Adresse de l'image pour la partie accomplie
    * @param string $image_droite Adresse de l'image pour la partie  raliser
    */
    public function __construct($min=0, $max=100, $image_gauche='H', $image_droite='.') {
        if(!isset(self::$compteur)) {
            self::$compteur = 0 ;
        }
        self::$compteur ++ ;
        if($min>$max) {
            $temp = $min ;
            $min = $max ;
            $max = $temp ;
        }
        $this->min = $min ;
        $this->max = $max ;
        $this->image_gauche = $image_gauche ;
        $this->image_droite = $image_droite ;
		print "\n" ;
    }
    /**
    * Destructeur
    */
    public function __destruct() {
        $this->min  = null ;
        $this->max  = null ;
        $this->avancement  = null ;
        $this->image_gauche  = null ;
        $this->image_droite  = null ;
    }
    /**
    * Cette mthode dessine la barre sur la console
    */
    public function dessine() {
		$chaine =  str_repeat( $this->image_droite, 20 ) ;
        	print $chaine ;
		return true ;
    }
    /**
    * Cette mthode fait avancer la barre de progession.
    *
    * Passer  cette mthode le nombre de l'avancement, compris entre min et max,
    * et c'est elle qui voit s'il est utile de faire progresser la barre.
    *
    * @return boolean Pour information, la mthode retourne TRUE lorsque la barre progresse, FALSE dans le cas contraire.
    */
    public function avance($nombre) {
        $nombre = max($nombre, $this->min) ;
        $nombre = min($nombre, $this->max) ;
        /* nombre compris entre 0 et 100 */
        $temp = ceil(100 * ($nombre - $this->min) / ($this->max - $this->min)) ;
        if($temp!=$this->avancement) {
            $this->avancement = $temp ;
            $temp1 = round($temp /5)  ;
            $temp2 = 20 - $temp1 ;
            print "\r" . str_repeat( $this->image_gauche, $temp1) . str_repeat( $this->image_droite , $temp2) . "  ". str_pad ( $temp, 2,'0',STR_PAD_LEFT) ." %" ;
            return true ;
        }
        return false ;
    }


}



function bdd_etat_verrous($bdd, $nom_table) {
	$stt = $bdd->prepare("select statut, count(*) from $nom_table group by statut order by statut ;") ;
	$stt->execute() ;
	$res = $stt->fetchAll( PDO::FETCH_NUM ) ;
	$chaine = "" ;
	foreach( $res as $resultat) {
		list( $statut, $eff ) = $resultat ;
		switch($statut) {
			case 0 :	$statut2 = "not attempted" ;	break ;
			case 1 :	$statut2 = "in progress" ;		break ;
			case 2 :	$statut2 = "done" ;		break ;
		}
		$chaine .= "\tStatut [$statut2] : $eff fichiers.\n" ;
	}
	return $chaine ;
}

function bdd_fichier_verrouille($bdd, $nom_table) {
	$stt = $bdd->prepare("SELECT nom FROM $nom_table WHERE statut=0 ORDER BY rand() LIMIT 1 ;") ;
	$stt->execute() ;
	$res = $stt->fetch( PDO::FETCH_NUM ) ; // only one line
	if( !$res ) {
		return false ; // no file left
	}
	$nom_fichier = $res[0] ;
	$stt2 = $bdd->prepare("UPDATE $nom_table SET statut=1 WHERE nom = :nom ;") ;
	$stt2->execute( array(":nom"=> $nom_fichier )) ;
	$count = $stt2->rowCount();
	if( $count!=1) {
		trigger_error("Warning, $count lines modified during the locking of file $nom_fichier .", E_USER_NOTICE) ;
	}
	return $nom_fichier ;
}


function bdd_fichier_deverrouille($bdd, $nom_table, $nom_fichier) {
	$stt2 = $bdd->prepare("UPDATE $nom_table SET statut=2 WHERE nom = :nom ;") ;
	$stt2->execute( array(":nom"=> $nom_fichier )) ;
	$count = $stt2->rowCount();
	if( $count!=1) {
		trigger_error("Warning, $count lines modified during the unlocking of file $nom_fichier .", E_USER_NOTICE) ;
		return false ;
	}
	return true ;
}


function debugue(PDOStatement $statement) {
	if( $statement->errorCode() != '00000') {
		trigger_error( implode("\t", $statement->errorInfo() ), E_USER_WARNING )  ;
		return FALSE ;
	}
	return TRUE ;
}

function get_file_list($bdd, $nom_table, $statut) {
	$stt = $bdd->prepare("SELECT nom FROM $nom_table WHERE statut=$statut ;") ;
	$stt->execute() ;
	$liste=array() ;
	while( $res = $stt->fetch( PDO::FETCH_NUM ) ) {
		$liste[] = $res[0] ;
	}
	return $liste ;
}



?>
